# Support Vector Regression (ML\_R\_4)

It is based on the concept of support vectors, which are the data points that are closest to the decision boundary, or the line that separates the data into different classes. SVR algorithm aims to find the best line that maximizes the margin between the support vectors and the decision boundary, this line is known as the support vector.&#x20;

This function aims to find the best line that maximizes the margin between the support vectors and the decision boundary, this line is known as the support vector. It can also be used with kernel functions to find the best decision boundary in non-linear regression problems.&#x20;

It is a powerful algorithm that is able to handle high dimensional and non-linear data, making it suitable for various regression problems.

## Sample Request

Build a multiple linear regression model named, *"SimpleModel"*

```javascript
{
    "project_id": 1,
    "parent_id": 7,
    "block_id": 8,
    "function_code": "ML_R_4",
    "args": {
        "model_name": "SimpleModel",
        "kernel": "rbf"
    }
}
```

## Building a Support Vector Regression model

## Support Vector Regression

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                             | Type   | Description                                                                |
| ------------------------------------------------ | ------ | -------------------------------------------------------------------------- |
| project\_id<mark style="color:red;">\*</mark>    | int    | The `id` of the current project                                            |
| block\_id<mark style="color:red;">\*</mark>      | int    | The `id` of the current block                                              |
| function\_code<mark style="color:red;">\*</mark> | string | The function code for current block                                        |
| parent\_id<mark style="color:red;">\*</mark>     | int    | The `id` of the previous block                                             |
| args<mark style="color:red;">\*</mark>           | object | Block arguments                                                            |
| model\_name<mark style="color:red;">\*</mark>    | String | Name of the model to be used for prediction.                               |
| kernel                                           | String | Specifies the kernel type to be used in the algorithm (defaults to "rbf"). |

{% tabs %}
{% tab title="200 Statemanagement object" %}

```javascript
{
    "status": "true",
    "message": {
        "id": 8,
        "project": 1,
        "block_id": 8,
        "parent_id": 7,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": "{\"SimpleModel\": {\"function_code\": \"ML_R_3\", \"model_url\": ""}}"
    }
}
```

{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="Python" %}

```
// Some code
```

{% endtab %}

{% tab title="Node" %}

```javascript
const project_id = 1
const parent_id = 7
const block_id = 8

supportVectorRegression = await client.support_vector_regression(project_id, parent_id, block_id, {
    model_name: "SimpleModel",
    kernel: "rbf"
});
```

{% endtab %}
{% endtabs %}

## Sample Request

Make predictions with the pre-built model passing an optional test data.

```javascript
{
    "project_id": 1,
    "parent_id": 8,
    "block_id": 9,
    "function_code": "ML_R_4_P",
    "args": {
        "model_name": "SimpleModel",
        "test_data": ""
    }
}
```

## Predicting with Support Vector Regression

## Support Vector Regression Predict

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                             | Type   | Description                                                            |
| ------------------------------------------------ | ------ | ---------------------------------------------------------------------- |
| model\_name<mark style="color:red;">\*</mark>    | String | Name of previously trained model to be used for prediction             |
| test\_data                                       | String | Input data for prediction. Defaults to `x_train_url` in StateManagment |
| project\_id<mark style="color:red;">\*</mark>    | int    | ID of the current project                                              |
| block\_id<mark style="color:red;">\*</mark>      | int    | ID of the current block                                                |
| parent\_id<mark style="color:red;">\*</mark>     | int    | ID of the previous block                                               |
| function\_code<mark style="color:red;">\*</mark> | String | Function code for the current block                                    |

{% tabs %}
{% tab title="200: OK Statemanagement object" %}

```javascript
{
    "status": "true",
    "message": {
        "id": 9,
        "project": 1,
        "block_id": 9,
        "parent_id": 8,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": "{\"y_pred_url\": ""}"
    }
}
```

{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="Python" %}

```
// Some code
```

{% endtab %}

{% tab title="Node" %}

```javascript
const project_id = 1
const parent_id = 7
const block_id = 8

supportVectorRegressionPredict = await client.support_vector_machine_predict(project_id, parent_id, block_id, {
       model_name: "SimpleModel",
      test_data: "http://cloud.autogonai.s3.amazonaws.com/f6fc6cf1-bdba-48d0-a7ac-fddd9609c826.csv"
    });
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.autogon.ai/autogon-engine-studio/machine-learning/support-vector-regression-ml_r_4.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
